# matrix-appservice-kakaotalk - A Matrix-KakaoTalk puppeting bridge.
# Copyright (C) 2022 Tulir Asokan, Andrew Ferrazzutti
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.
from typing import Union

from enum import IntEnum


class KnownChatType(IntEnum):
    FEED = 0
    TEXT = 1
    PHOTO = 2
    VIDEO = 3
    CONTACT = 4
    AUDIO = 5
    DITEMEMOTICON = 6
    DITEMGIFT = 7
    DITEMIMG = 8
    KAKAOLINKV1 = 9
    AVATAR = 11
    STICKER = 12
    SCHEDULE = 13
    VOTE = 14
    LOTTERY = 15
    MAP = 16
    PROFILE = 17
    FILE = 18
    STICKERANI = 20
    NUDGE = 21
    ACTIONCON = 22
    SEARCH = 23
    POST = 24
    STICKERGIF = 25
    REPLY = 26
    MULTIPHOTO = 27
    VOIP = 51
    LIVETALK = 52
    CUSTOM = 71
    ALIM = 72
    PLUSFRIEND = 81
    PLUSEVENT = 82
    PLUSFRIENDVIRAL = 83
    OPEN_SCHEDULE = 96
    OPEN_VOTE = 97
    OPEN_POST = 98

ChatType = Union[KnownChatType, int]


DELETED_MESSAGE_OFFSET = 16384;


__all__ = [
    "KnownChatType",
    "ChatType",
    "DELETED_MESSAGE_OFFSET",
]
