# matrix-appservice-kakaotalk - A Matrix-KakaoTalk puppeting bridge.
# Copyright (C) 2022 Tulir Asokan, Andrew Ferrazzutti
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.
from enum import IntEnum


class OpenLinkType(IntEnum):
    PROFILE = 1
    CHANNEL = 2


class OpenChannelUserPerm(IntEnum):
    OWNER = 1
    NONE = 2
    MANAGER = 4
    BOT = 8


class OpenProfileType(IntEnum):
    MAIN = 1
    KAKAO_ANON = 2
    KAKAO_ANON_2 = 4
    UNKNOWN_1 = 8
    OPEN_PROFILE = 16


class OpenChannelType(IntEnum):
    UNKNOWN = 0
    DIRECT = 1
    GROUP = 2


__all__ = [
    "OpenLinkType",
    "OpenChannelUserPerm",
    "OpenProfileType",
    "OpenChannelType",
]
