# matrix-appservice-kakaotalk - A Matrix-KakaoTalk puppeting bridge.
# Copyright (C) 2022 Tulir Asokan, Andrew Ferrazzutti
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.
from typing import Optional

from attr import dataclass

from mautrix.types import SerializableAttrs

from ..bson import Long


@dataclass
class ChannelUser(SerializableAttrs):
    userId: Long


@dataclass(kw_only=True)
class PartialOpenLinkComponent(SerializableAttrs):
    """Substitute for Partial<OpenLinkComponent>"""
    linkId: Optional[Long] = None


@dataclass
class OpenChannelUser(ChannelUser, PartialOpenLinkComponent):
    pass


__all__ = [
    "ChannelUser",
    "PartialOpenLinkComponent",
    "OpenChannelUser",
]
